#define TOTAL_NUM_OF_PM_OVLYS 3

#include "2191asm.h"

.section/pm interrupts;
.extern start;

Reset_Vector:
	jump start; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

PowerDown_Vector:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

Loop_PCStack_Vector:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

Emulation_Kernel_Vector:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_4:

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Here we wish to assign the MEMDMA Interrupt as the highest priority since no other peripherals are active.
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////

//	ena sec_reg;														// enable the secondary ALU registers
	iopg = Memory_DMA_Controller_Page;			// switch to MEM DMA IO page
	ax0 = 0x1;															// writing a 1 to bit #1 of this register clears the interrupt
	io(DMACW_IRQ) = ax0;										// for the write channel so that it doesn't occur again
	io(DMACR_IRQ) = ax0;										// same here for the read channel
	
	rti; rti; rti; rti;											// the remainder of these RTI instructions are just used here as placeholders
	rti; rti; rti; rti;
	rti; rti; rti; rti;

	
//	ax0 = dm(ov_stack);											// get the overlay ID# from the software stack (this value was saved previously by the overlay manager)
//	ay0 = TOTAL_NUM_OF_PM_OVLYS;						// let ay0 equal the total number of PM overlays in our project
//	ar = ax0 - ay0;													// determine if the overlay module that was DMAed into internal memory was for PM or DM
	
//	if lt jump Goto_Target;									// if it's a PM overlay then we need to jump to its address
//	rti;																		// otherwise it's a DM overlay so return back to main program (and enable primary registers again)

//Goto_Target:
	
//	pop sts;																// pop the imask register (wtf??????)
//	dm(ov_stack+18) = i7;										// context save i7 register
//	i7 = dm(ov_stack+19);										// i7 equals overlay target address
//	jump (i7) (db);													// jump to the target address of the overlay (the RTS in overlay will restore the PC stack)
//	i7 = dm(ov_stack+18);										// context restore i7 register
//	dis sec_reg;														// disable the secondary registers
	
	rti; rti; rti; rti;											// the remainder of these RTI instructions are just used here as placeholders
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

/*
// Here we wish to assign the MEMDMA Interrupt as the highest priority since no other
// peripherals are active.

	iopg = Memory_DMA_Controller_Page;			// switch to MEM DMA IO page
	ax0 = 0x1;															// writing a 1 to bit #1 of this register clears the interrupt
	io(DMACW_IRQ) = ax0;										// for the write channel so that it doesn't occur again
	io(DMACR_IRQ) = ax0;										// same here for the read channel
	rti;																		// return from interrupt back to main program

	// 11-05-01: modified the ISR to jump to the target overlay address after the overlay has been loaded in via DMA
//	dm(ov_stack+18) = i7;										// context save i7 register
//	i7 = dm(ov_stack+19);										// get target address of the overlay function
//	jump (i7) (db);													// jump to overlay function
//	i7 = dm(ov_stack+18);										// context restore i7 register
//	nop;																		// NOP needed here to fill the delay slot
	
	// 11-07-01: commented out the above code. now overlay manager has idle instruction needed for DMA completion
	// if the desired overlay is not loaded. if the desired overlay is loaded then we do not need to set up the MEM DMA
	// and therefore we will not reach this interrupt code!!
	rti; rti; rti; rti;											// the remainder of these RTI instructions are just used here as placeholders
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti;

*/

User_Interrupt_5:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_6:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_7:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_8:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_9:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_10:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_11:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_12:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_13:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_14:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

User_Interrupt_15:
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;
	rti; rti; rti; rti;

